select an.nome
    , an.numero
    , se.nome as setor_atual
    , up.data as Ultimo_Parto
    , utentf.data as Ultima_inseminacao_fertil
    , (up.data - putentf.data) as intervalo_ultima_ins_e_ult_parto
from animal an
    left join setor se on se.cdsetor = an.cdsetor
    left join reproducao up on up.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
            order by re.data desc)
    left join reproducao udigp on udigp.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 4
                and re.diagnostico = 'P'
            order by re.data desc)
    left join reproducao utentf on utentf.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.data < udigp.data
                and re.cdtiporeproducao in (1,2,3)
            order by re.data desc)
    left join reproducao putentf on putentf.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.data < (select first 1 re1.dtinicio
                                from lactacao re1
                                where re1.cdanimal = an.cdanimal
                                    and re1.dtinicio < up.data
                                order by re1.dtinicio desc)
                and re.cdtiporeproducao in (1,2,3)
            order by re.data desc)
where an.sexo = 'F'
order by an.numordenado

